all: date_dim time_dim item customer customer_demographics household_demographics customer_address store promotion warehouse ship_mode reason income_band call_center web_page catalog_page web_site store_sales store_returns web_sales web_returns catalog_sales catalog_returns inventory
date_dim:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/date_dim.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table date_dim (1/24).'
time_dim:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/time_dim.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table time_dim (2/24).'
item:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/item.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table item (3/24).'
customer:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/customer.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table customer (4/24).'
customer_demographics:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/customer_demographics.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table customer_demographics (5/24).'
household_demographics:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/household_demographics.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table household_demographics (6/24).'
customer_address:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/customer_address.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table customer_address (7/24).'
store:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/store.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table store (8/24).'
promotion:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/promotion.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table promotion (9/24).'
warehouse:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/warehouse.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table warehouse (10/24).'
ship_mode:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/ship_mode.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table ship_mode (11/24).'
reason:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/reason.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table reason (12/24).'
income_band:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/income_band.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table income_band (13/24).'
call_center:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/call_center.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table call_center (14/24).'
web_page:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/web_page.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table web_page (15/24).'
catalog_page:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/catalog_page.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table catalog_page (16/24).'
web_site:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/web_site.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5 --hivevar SOURCE=tpcds_text_5             --hivevar SCALE=5 	    --hivevar REDUCERS=5 	    --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table web_site (17/24).'
store_sales:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/store_sales.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5             --hivevar SCALE=5 	    --hivevar SOURCE=tpcds_text_5 --hivevar BUCKETS=1 	    --hivevar RETURN_BUCKETS=1 --hivevar REDUCERS=5 --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table store_sales (18/24).'
store_returns:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/store_returns.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5             --hivevar SCALE=5 	    --hivevar SOURCE=tpcds_text_5 --hivevar BUCKETS=1 	    --hivevar RETURN_BUCKETS=1 --hivevar REDUCERS=5 --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table store_returns (19/24).'
web_sales:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/web_sales.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5             --hivevar SCALE=5 	    --hivevar SOURCE=tpcds_text_5 --hivevar BUCKETS=1 	    --hivevar RETURN_BUCKETS=1 --hivevar REDUCERS=5 --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table web_sales (20/24).'
web_returns:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/web_returns.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5             --hivevar SCALE=5 	    --hivevar SOURCE=tpcds_text_5 --hivevar BUCKETS=1 	    --hivevar RETURN_BUCKETS=1 --hivevar REDUCERS=5 --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table web_returns (21/24).'
catalog_sales:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/catalog_sales.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5             --hivevar SCALE=5 	    --hivevar SOURCE=tpcds_text_5 --hivevar BUCKETS=1 	    --hivevar RETURN_BUCKETS=1 --hivevar REDUCERS=5 --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table catalog_sales (22/24).'
catalog_returns:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/catalog_returns.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5             --hivevar SCALE=5 	    --hivevar SOURCE=tpcds_text_5 --hivevar BUCKETS=1 	    --hivevar RETURN_BUCKETS=1 --hivevar REDUCERS=5 --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table catalog_returns (23/24).'
inventory:
	@beeline -n root -u 'jdbc:hive2://hive.test.local:10000'   -i settings/load-partitioned.sql -f ddl-tpcds/bin_partitioned/inventory.sql 	    --hivevar DB=tpcds_bin_partitioned_parquet_5             --hivevar SCALE=5 	    --hivevar SOURCE=tpcds_text_5 --hivevar BUCKETS=1 	    --hivevar RETURN_BUCKETS=1 --hivevar REDUCERS=5 --hivevar FILE=parquet 2> /dev/null 1> /dev/null && echo 'Optimizing table inventory (24/24).'
